package com.mpaas.demo.analytics.testcase;

import com.mpaas.diagnose.IDiagnoseCheckList;
import com.mpaas.diagnose.IDiagnoseController;

import java.util.LinkedList;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class AnalyticsDiagnoseCheckList implements IDiagnoseCheckList {

    @Override
    public LinkedList<IDiagnoseController> getDiagnoseControllers() {
        LinkedList<IDiagnoseController> list = new LinkedList<>();
        reflectAndAdd(list, "com.mpaas.demo.analytics.testcase.AnalyticsDiagnoseController");
        return list;
    }

    private void reflectAndAdd(LinkedList<IDiagnoseController> list, String className) {
        IDiagnoseController diagnoseController = null;
        try {
            Class clazz = Class.forName(className);
            diagnoseController = (IDiagnoseController) clazz.newInstance();
        } catch (Exception e) {
            diagnoseController = null;
        }
        if (null != diagnoseController) {
            list.add(diagnoseController);
        }
    }
}
