package com.mpaas.demo.analytics.testcase;

import com.alipay.mobile.framework.LauncherApplicationAgent;
import com.mpaas.demo.analytics.testcase.listener.UploadListener;
import com.mpaas.diagnose.DiagnoseService;
import com.mpaas.diagnose.IDiagnoseController;
import com.mpaas.diagnose.ILogListener;

import java.util.LinkedList;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class AnalyticsDiagnoseController implements IDiagnoseController {

    public static DiagnoseService service;

    @Override
    public void init() {
        service = LauncherApplicationAgent.getInstance().getMicroApplicationContext().findServiceByInterface(DiagnoseService.class.getName());
        service.registerCase(EnvironmentCase.getInstance().getCaseInfo());
        service.registerCase(LogStrategyCase.getInstance().getCaseInfo());
        service.registerCase(ClientLaunchCase.getInstance().getCaseInfo());
        service.registerCase(UserLoginCase.getInstance().getCaseInfo());
        service.registerCase(EventCase.getInstance().getCaseInfo());
        service.registerCase(LaunchTimeCase.getInstance().getCaseInfo());
        service.registerCase(AutoCase.getInstance().getCaseInfo());
        service.registerCase(UploadCase.getInstance().getCaseInfo());
        service.registerCase(BlockCase.getInstance().getCaseInfo());
        service.registerCase(AnrCase.getInstance().getCaseInfo());
        service.registerCase(CrashCase.getInstance().getCaseInfo());
    }

    @Override
    public LinkedList<ILogListener> registerLogListeners() {
        LinkedList<ILogListener> logListeners = new LinkedList<>();
        logListeners.add(new UploadListener());
        return logListeners;
    }

    @Override
    public void runAllCase() {
        EnvironmentCase.getInstance().run();
        LogStrategyCase.getInstance().run();
        ClientLaunchCase.getInstance().run();
        UserLoginCase.getInstance().run();
        EventCase.getInstance().run();
        AutoCase.getInstance().run();
        LaunchTimeCase.getInstance().run();
        BlockCase.getInstance().run();
        AnrCase.getInstance().run();
        UploadCase.getInstance().run();
        CrashCase.getInstance().run();
    }
}
