package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.alipay.mobile.common.logging.api.monitor.MTBizReportName;
import com.mpaas.demo.analytics.testcase.util.ThreadUtil;
import com.mpaas.diagnose.CaseInfo;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class AnrCase extends BaseCase {

    private static AnrCase sInstance;
    private CaseInfo mCaseInfo;

    private AnrCase() {
    }

    public static AnrCase getInstance() {
        if (sInstance == null) {
            synchronized (AnrCase.class) {
                if (sInstance == null) {
                    sInstance = new AnrCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-0000009",
                    "检测卡死日志",
                    "自动检测卡死日志",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        ThreadUtil.runOnMainThread(new Runnable() {
            @Override
            public void run() {
                ThreadUtil.sleep(6);
                ThreadUtil.wake();
            }
        });
        ThreadUtil.sleep();

        String category = LogCategory.CATEGORY_HIGHAVAIL;
        SparseArray<String> identifiers = new SparseArray<>(2);
        identifiers.put(13, MTBizReportName.MTBIZ_APM);
        identifiers.put(14, "APM_ANR");
        checkLogExist(category, identifiers);
    }
}
