package com.mpaas.demo.analytics.testcase;

import android.app.Activity;
import android.text.TextUtils;
import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.alipay.mobile.common.logging.api.LoggerFactory;
import com.alipay.mobile.common.logging.api.behavor.BehavorID;
import com.alipay.mobile.framework.LauncherApplicationAgent;
import com.alipay.mobile.framework.MicroApplicationContext;
import com.mpaas.demo.analytics.testcase.util.ThreadUtil;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.mas.adapter.api.MPLogger;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class AutoCase extends BaseCase {

    private static AutoCase sInstance;
    private CaseInfo mCaseInfo;
    private static final int REQUEST_CODE = 233;

    private AutoCase() {
    }

    public static AutoCase getInstance() {
        if (sInstance == null) {
            synchronized (AutoCase.class) {
                if (sInstance == null) {
                    sInstance = new AutoCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-000006",
                    "检测自动化日志",
                    "手动点击测试页面，自动检测自动化日志",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        MPLogger.enableAutoLog();
        // 自动打开和关闭页面
        MicroApplicationContext microApplicationContext =
                LauncherApplicationAgent.getInstance().getMicroApplicationContext();
        String className = "com.mpaas.demo.analytics.AutomationActivity";
        microApplicationContext.startActivityForResult(
                microApplicationContext.getTopApplication(), className, REQUEST_CODE);
        Activity activity = null;
        while (activity == null ||
                !TextUtils.equals(activity.getClass().getName(), className)) {
            ThreadUtil.sleep(1);
            activity = microApplicationContext.getTopActivity().get();
        }
        final Activity topActivity = activity;
        ThreadUtil.runOnMainThread(new Runnable() {
            @Override
            public void run() {
                topActivity.finish();
                ThreadUtil.wake();
            }
        });
        ThreadUtil.sleep();

        String category = LogCategory.CATEGORY_AUTOUSERBEHAVOR;
        LoggerFactory.getLogContext().flush(category, true);
        SparseArray<String> identifiers = new SparseArray<>(1);
        identifiers.put(8, BehavorID.AUTOOPENPAGE);
        checkLogExist(category, identifiers);
    }

}
