package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.mpaas.demo.analytics.testcase.util.LogFileUtil;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

import java.util.List;

/**
 * Created by xingcheng on 2019/3/6.
 */

public abstract class BaseCase implements ICase {

    protected void reportSuccess(String msg) {
        AnalyticsDiagnoseController.service.reportCase(getCaseInfo(), CaseInfo.RESULT_CODE_SUCCESS, msg);
    }

    protected void reportFailure(String msg) {
        AnalyticsDiagnoseController.service.reportCase(getCaseInfo(), CaseInfo.RESULT_CODE_FAIL, msg);
    }

    protected boolean checkLogExist(String category, SparseArray<String> identifiers) {
        List<String> logs = LogFileUtil.findLogInFile(category, identifiers);
        if (logs == null || logs.size() == 0) {
            StringBuilder msg = new StringBuilder("未找到日志文件" + category + "，\n或没有");
            for (int i = 0; i < identifiers.size(); i++) {
                msg.append("字段").append(identifiers.keyAt(i)).append("为").append(identifiers.valueAt(i));
            }
            msg.append("的日志");
            reportFailure(msg.toString());
            return false;

        } else {
            StringBuilder msg = new StringBuilder("找到日志：\n");
            for (String log : logs) {
                msg.append(log).append("\n\n");
            }
            reportSuccess(msg.toString());
            return true;
        }
    }

}
