package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.mpaas.demo.analytics.testcase.util.ThreadUtil;
import com.mpaas.diagnose.CaseInfo;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class BlockCase extends BaseCase {

    private static BlockCase sInstance;
    private CaseInfo mCaseInfo;

    private BlockCase() {
    }

    public static BlockCase getInstance() {
        if (sInstance == null) {
            synchronized (BlockCase.class) {
                if (sInstance == null) {
                    sInstance = new BlockCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-0000008",
                    "检测卡顿日志",
                    "自动检测卡顿日志",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        ThreadUtil.runOnMainThread(new Runnable() {
            @Override
            public void run() {
                ThreadUtil.sleep(3);
                ThreadUtil.wake();
            }
        });
        ThreadUtil.sleep();

        String category = LogCategory.CATEGORY_APM;
        SparseArray<String> identifiers = new SparseArray<>(2);
        identifiers.put(14, "performance");
        identifiers.put(15, "lag");
        checkLogExist(category, identifiers);
    }
}
