package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.mpaas.demo.analytics.testcase.util.ThreadUtil;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.mas.adapter.api.MPLogger;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class ClientLaunchCase extends BaseCase {

    private static ClientLaunchCase sInstance;
    private CaseInfo mCaseInfo;

    private ClientLaunchCase() {
    }

    public static ClientLaunchCase getInstance() {
        if (sInstance == null) {
            synchronized (ClientLaunchCase.class) {
                if (sInstance == null) {
                    sInstance = new ClientLaunchCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-000002",
                    "检测设备报活",
                    "自动检测设备报活",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        MPLogger.reportClientLaunch();

        ThreadUtil.sleep(1);

        String category = LogCategory.CATEGORY_ALIVEREPORT;
        SparseArray<String> identifiers = new SparseArray<>(1);
        identifiers.put(15, "reportActive");
        checkLogExist(category, identifiers);
    }
}
