package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.mpaas.diagnose.CaseInfo;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class CrashCase extends BaseCase {

    private static CrashCase sInstance;
    private CaseInfo mCaseInfo;

    private CrashCase() {
    }

    public static CrashCase getInstance() {
        if (sInstance == null) {
            synchronized (CrashCase.class) {
                if (sInstance == null) {
                    sInstance = new CrashCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-0000010",
                    "检测闪退日志",
                    "自动检测闪退日志",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        String category = LogCategory.CATEGORY_CRASH;
        SparseArray<String> identifiers = new SparseArray<>(1);
        identifiers.put(13, "MonitorPoint_Crash");
        boolean exist = checkLogExist(category, identifiers);
        // 如果没找到闪退日志就制造一个，需要再次启动后再检查一次
        if (!exist) {
            throw new IllegalArgumentException("模拟闪退");
        }
    }
}
