package com.mpaas.demo.analytics.testcase;

import com.alipay.mobile.common.logging.api.LoggerFactory;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class EnvironmentCase extends BaseCase {

    private static EnvironmentCase sInstance;
    private CaseInfo mCaseInfo;

    private EnvironmentCase() {
    }

    public static EnvironmentCase getInstance() {
        if (sInstance == null) {
            synchronized (EnvironmentCase.class) {
                if (sInstance == null) {
                    sInstance = new EnvironmentCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-000000",
                    "检测日志环境配置",
                    "自动输出日志环境配置",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        String productId = LoggerFactory.getLogContext().getProductId();
        String[] split = productId.split("_");
        String appId = split[0];
        split = split[1].split("-");
        String platform = split[0];
        String workspaceId = split[1];
        String logHost = LoggerFactory.getLogContext().getLogHost();
        String result = "appId = " + appId
                + "\n" + "workspaceId = " + workspaceId
                + "\n" + "platform = " + platform
                + "\n" + "logHost = " + logHost;
        reportSuccess(result);
    }
}
