package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.alipay.mobile.common.logging.api.LoggerFactory;
import com.mpaas.demo.analytics.testcase.util.ThreadUtil;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.mas.adapter.api.MPLogger;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class EventCase extends BaseCase {

    private static EventCase sInstance;
    private CaseInfo mCaseInfo;

    private EventCase() {
    }

    public static EventCase getInstance() {
        if (sInstance == null) {
            synchronized (EventCase.class) {
                if (sInstance == null) {
                    sInstance = new EventCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-000004",
                    "检测自定义日志",
                    "自动检测自定义日志",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        String logId = "eventTest";
        String bizType = "Test";
        MPLogger.event(logId, bizType);
        LoggerFactory.getLogContext().flush(bizType, true);

        ThreadUtil.sleep(1);

        String category = bizType;
        SparseArray<String> identifiers = new SparseArray<>(1);
        identifiers.put(15, logId);
        checkLogExist(category, identifiers);
    }
}
