package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.mpaas.diagnose.CaseInfo;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class LaunchTimeCase extends BaseCase {

    private static LaunchTimeCase sInstance;
    private CaseInfo mCaseInfo;

    private LaunchTimeCase() {
    }

    public static LaunchTimeCase getInstance() {
        if (sInstance == null) {
            synchronized (LaunchTimeCase.class) {
                if (sInstance == null) {
                    sInstance = new LaunchTimeCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-000005",
                    "检测启动速度日志",
                    "自动检测启动速度日志",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // app启动时launcher里已经调用了上报启动速度日志，不需要再调用了
        String category = LogCategory.CATEGORY_PERFORMANCE;
        SparseArray<String> identifiers = new SparseArray<>(1);
        identifiers.put(12, "time_startup");
        checkLogExist(category, identifiers);
    }
}
