package com.mpaas.demo.analytics.testcase;

import android.util.SparseArray;

import com.alipay.mobile.common.logging.api.LogCategory;
import com.mpaas.demo.analytics.testcase.util.ThreadUtil;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.mas.adapter.api.MPLogger;

/**
 * Created by xingcheng on 2019/2/26.
 */

public class UserLoginCase extends BaseCase {

    private static UserLoginCase sInstance;
    private CaseInfo mCaseInfo;

    private UserLoginCase() {
    }

    public static UserLoginCase getInstance() {
        if (sInstance == null) {
            synchronized (UserLoginCase.class) {
                if (sInstance == null) {
                    sInstance = new UserLoginCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Analytics",
                    "Analytics-000003",
                    "检测用户报活",
                    "自动检测用户报活",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        String userId = "mpaas_demo_test";
        MPLogger.reportUserLogin(userId);

        ThreadUtil.sleep(1);

        String category = LogCategory.CATEGORY_ALIVEREPORT;
        SparseArray<String> identifiers = new SparseArray<>(2);
        identifiers.put(7, userId);
        identifiers.put(15, "login");
        checkLogExist(category, identifiers);
    }
}
