package com.alipay.mobile.antui.excutor;

import com.alipay.mobile.antui.excutor.impl.BaseLoggerExecutorImpl;
import com.alipay.mobile.antui.excutor.impl.BaseLottieExecutorImpl;

/**
 * Created by xuanmu on 17/9/1.
 */

public class AntUIExecutorManager {

    private static AntUIExecutorManager sInstance;
    private LoggerExecutor loggerExecutor;
    private ConfigExecutor configExecutor;
    private FileLoadExecutor fileLoadExecutor;
    private LottieViewExecutor lottieViewExecutor;

    private AntUIExecutorManager() {
        loggerExecutor = new BaseLoggerExecutorImpl();
        lottieViewExecutor = new BaseLottieExecutorImpl();
    }

    public static AntUIExecutorManager getInstance() {
        if(sInstance == null) {
            synchronized(AntUIExecutorManager.class) {
                if(sInstance == null) {
                    sInstance = new AntUIExecutorManager();
                }
            }
        }
        return sInstance;
    }

    public void setLoggerExecutor(LoggerExecutor loggerExecutor){
        this.loggerExecutor = loggerExecutor;
    }

    public LoggerExecutor getLoggerExecutor(){
        return this.loggerExecutor;
    }

    public void setLottieViewExecutor(LottieViewExecutor lottieViewExecutor) {
        this.lottieViewExecutor = lottieViewExecutor;
    }

    public LottieViewExecutor getLottieViewExecutor() {
        return lottieViewExecutor;
    }


    public void setConfigExecutor(ConfigExecutor configExecutor) {
        this.configExecutor = configExecutor;
    }

    public ConfigExecutor getConfigExecutor() {
        return configExecutor;
    }


    public void setFileLoadExecutor(FileLoadExecutor fileLoadExecutor) {
        this.fileLoadExecutor = fileLoadExecutor;
    }

    public FileLoadExecutor getFileLoadExecutor() {
        return fileLoadExecutor;
    }
}
