package com.alipay.mobile.antui.excutor.impl;

import android.animation.Animator;
import android.animation.ValueAnimator;
import android.content.Context;
import android.view.View;
import android.widget.ProgressBar;

import com.mpaas.demo.antui.R;
import com.alipay.mobile.antui.excutor.LottieViewExecutor;

import org.json.JSONObject;

/**
 * Created by xuanmu on 17/11/28.
 */

public class BaseLottieExecutorImpl implements LottieViewExecutor {
    @Override
    public View createLottieAnimation(Context context, JSONObject fileObject) {
        ProgressBar progressBar = new ProgressBar(context);
        progressBar.setIndeterminateDrawable(context.getResources().getDrawable(R.drawable.drawable_default_process));
        return progressBar;
    }

    @Override
    public void setProgress(View view, float progress) {
        if (view instanceof ProgressBar) {
            ((ProgressBar) view).setProgress((int) progress);
        }
    }

    @Override
    public void setMinAndMaxProgress(View view, float min, float max) {

    }

    @Override
    public void loop(View view, boolean isLoop) {
        if (view instanceof ProgressBar) {
            ((ProgressBar) view).setIndeterminate(isLoop);
        }
    }

    @Override
    public void playAnimation(View view) {
        if (view instanceof ProgressBar) {
            view.setVisibility(View.VISIBLE);
        }
    }

    @Override
    public void cancelAnimation(View view) {
        if (view instanceof ProgressBar) {
            view.setVisibility(View.GONE);
        }
    }

    @Override
    public void pauseAnimation(View view) {

    }

    @Override
    public void setScale(View view, float scale) {

    }

    @Override
    public void addAnimatorUpdateListener(View view, ValueAnimator.AnimatorUpdateListener animatorUpdateListener) {

    }

    @Override
    public void addAnimatorListener(View view, Animator.AnimatorListener animatorListener) {

    }

    @Override
    public void setImageAssetsDelegateFolder(View view, String imageAssetsFolder) {

    }
}
