package com.mpaas.demo.configservice;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.View;
import android.widget.TextView;

import com.alipay.mobile.antui.basic.AUButton;
import com.alipay.mobile.antui.basic.AUEditText;
import com.alipay.mobile.antui.basic.AUTitleBar;
import com.alipay.mobile.base.config.ConfigService;
import com.alipay.mobile.framework.app.ui.BaseActivity;
import com.mpaas.configservice.adapter.api.MPConfigService;
import com.mpaas.demo.sharedres.MenuPopupWindow;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by mengfei on 2018/7/20.
 */

public class ConfigServiceActivity extends BaseActivity implements View.OnClickListener, ConfigService.ConfigChangeListener {
    AUButton mSyncBtn, mMonitorChangeBtn, mSearch;
    AUEditText mSearchInput;
    TextView mResult;
    private AUTitleBar mTitle;


    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_configservice);
        mSearch = (AUButton) findViewById(R.id.search);
        mSearch.setOnClickListener(this);
        mSearchInput = (AUEditText) findViewById(R.id.search_input);
        mSyncBtn = (AUButton) findViewById(R.id.sync_config);
        mSyncBtn.setOnClickListener(this);
        mMonitorChangeBtn = (AUButton) findViewById(R.id.monitor_change);
        mMonitorChangeBtn.setOnClickListener(this);
        mResult = (TextView) findViewById(R.id.result);
        mTitle = (AUTitleBar) findViewById(R.id.title_tab);
        mTitle.setTitleText(getString(R.string.title), (int) getResources().getDimension(com.mpaas.demo.sharedres.R.dimen.text_size)
                , getResources().getColor(com.mpaas.demo.sharedres.R.color.title_color));
        mTitle.getRightButtonIconView().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                MenuPopupWindow popupWindow = new MenuPopupWindow(ConfigServiceActivity.this);
                popupWindow.showAsDropDown(mTitle.getRightButtonIconView(), 0, 0);
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        // ConfigChangeListener 内部会以软引用形式保存
        // 所以如果 ConfigChangeListener 是 activity 的话，要在 destroy 的时候进行移除
        MPConfigService.removeConfigChangeListener(this);
    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        switch (id) {
            case R.id.search:
                String key = mSearchInput.getText().toString();
                String value = MPConfigService.getConfig(key);
                mResult.setText(value);
                break;
            case R.id.sync_config:
                MPConfigService.loadConfigImmediately(0);
                break;
            case R.id.monitor_change:
                MPConfigService.addConfigChangeListener(this);
                break;
        }
    }

    @Override
    public List<String> getKeys() {
        List<String> keys = new ArrayList<String>();
        keys.add("test1");
        return keys;
    }

    @Override
    public void onConfigChange(String s, String s1) {
        mResult.setText(getString(R.string.monitor_result) + " key:" + s + " value:" + s1);
    }
}
