package com.mpaas.demo.configservice.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

public class ConfigChangeCase implements ICase {
    private static ConfigChangeCase sInstance;
    private CaseInfo mCaseInfo;

    private ConfigChangeCase() {
    }

    public static ConfigChangeCase getInstance() {
        if (sInstance == null) {
            synchronized (ConfigChangeCase.class) {
                if (sInstance == null) {
                    sInstance = new ConfigChangeCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "ConfigService",
                    "ConfigService-000002",
                    "检测获取开关 change 监听",
                    "手动进入开关配置页面，点击\"监听test1配置的变化\"，在后台修改 test1 的值，然后再点击\"立即更新配置\"",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
