package com.mpaas.demo.configservice.testcase;

import com.mpaas.diagnose.DiagnoseService;
import com.mpaas.diagnose.IDiagnoseController;
import com.mpaas.diagnose.ILogListener;
import com.mpaas.framework.adapter.api.MPFramework;

import java.util.LinkedList;

public class ConfigServiceDiagnoseController implements IDiagnoseController {

    public static DiagnoseService service;

    @Override
    public void init() {
        service = MPFramework.getExternalService(DiagnoseService.class.getName());
        registerGetConfigCase();
        registerRefreshConfigCase();
        registerConfigChangeCase();
    }

    @Override
    public LinkedList<ILogListener> registerLogListeners() {
        LinkedList<ILogListener> listeners = new LinkedList<>();
        listeners.add(new ConfigServiceLogListener());
        return listeners;
    }

    @Override
    public void runAllCase() {
        try {
            GetConfigCase.getInstance().run();
            Thread.sleep(1000);
            RefreshConfigCase.getInstance().run();
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    private void registerGetConfigCase() {
        service.registerCase(GetConfigCase.getInstance().getCaseInfo());
    }

    private void registerRefreshConfigCase() {
        service.registerCase(RefreshConfigCase.getInstance().getCaseInfo());
    }

    private void registerConfigChangeCase() {
        service.registerCase(ConfigChangeCase.getInstance().getCaseInfo());
    }

}
