package com.mpaas.demo.configservice.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.mpaas.diagnose.ILogListener;

import java.util.List;

import static com.alipay.mobile.common.logging.api.LogEvent.Level.INFO_INT;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class ConfigServiceLogListener implements ILogListener {
    @Override
    public String getTag() {
        return "ConfigService";
    }

    @Override
    public List<String> getProcesses() {
        return null;
    }

    @Override
    public boolean canFuzzyMatch() {
        return false;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {
        if (logEvent.getLevel().levelInt == INFO_INT) {
            // 检测开关更新
            if (logEvent.getMessage().contains("resp.success")) {
                if (logEvent.getMessage().contains("!!!")) {
                    ConfigServiceDiagnoseController.service.reportCase(RefreshConfigCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "拉取成功，但服务端没有开关变化");
                } else {
                    ConfigServiceDiagnoseController.service.reportCase(RefreshConfigCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                }
                return;
            }
            // 检测开关变动
            if (logEvent.getMessage().contains("notifyConfigChange start key is ")) {
                if (logEvent.getMessage().contains("test1")) {
                    ConfigServiceDiagnoseController.service.reportCase(ConfigChangeCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                }
                return;
            }
        }
    }
}
