package com.mpaas.demo.configservice.testcase;

import android.text.TextUtils;

import com.mpaas.configservice.adapter.api.MPConfigService;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class GetConfigCase implements ICase {
    private static GetConfigCase sInstance;
    private CaseInfo mCaseInfo;

    private GetConfigCase() {
    }

    public static GetConfigCase getInstance() {
        if (sInstance == null) {
            synchronized (GetConfigCase.class) {
                if (sInstance == null) {
                    sInstance = new GetConfigCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "ConfigService",
                    "ConfigService-000000",
                    "检测获取开关",
                    "自动检测开关是否能正常获取。",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        String result = MPConfigService.getConfig("test1");
        if (!TextUtils.isEmpty(result)) {
            ConfigServiceDiagnoseController.service.reportCase(GetConfigCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
        } else {
            ConfigServiceDiagnoseController.service.reportCase(GetConfigCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "获取失败，getConfig 结果为空");
        }
    }
}
