package com.mpaas.demo.configservice.testcase;

import com.mpaas.configservice.adapter.api.MPConfigService;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;

public class RefreshConfigCase implements ICase {
    private static RefreshConfigCase sInstance;
    private CaseInfo mCaseInfo;

    private RefreshConfigCase() {
    }

    public static RefreshConfigCase getInstance() {
        if (sInstance == null) {
            synchronized (RefreshConfigCase.class) {
                if (sInstance == null) {
                    sInstance = new RefreshConfigCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "ConfigService",
                    "ConfigService-000001",
                    "检测开关刷新",
                    "自动检测开关是否能正常刷新。",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        ConfigServiceDiagnoseController.service.reportCase(RefreshConfigCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "开始刷新更新请求，但暂未获取到结果");
        MPConfigService.loadConfigImmediately(0);
    }
}
