package com.mpaas.demo.framework.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by mengfei on 2019/2/26.
 */

public class ActivityApplicationTestCase implements ICase {

    private static ActivityApplicationTestCase sInstance;
    private CaseInfo mCaseInfo;

    private ActivityApplicationTestCase() {
    }

    public static ActivityApplicationTestCase getInstance() {
        if (sInstance == null) {
            synchronized (ActivityApplicationTestCase.class) {
                if (sInstance == null) {
                    sInstance = new ActivityApplicationTestCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Framework",
                    "Framework-ActivityApplication",
                    "ActivityApplication组件",
                    "ActivityApplication组件的主要作用在于管理和组织各个Activity，专门用于解决跳转到另一个Bundle界面的问题",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // 手动检测 do nothing
    }
}
