package com.mpaas.demo.framework.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by mengfei on 2019/2/26.
 */

public class BroadcastReceiverTestCase implements ICase {
    private static BroadcastReceiverTestCase sInstance;
    private CaseInfo mCaseInfo;

    private BroadcastReceiverTestCase() {
    }

    public static BroadcastReceiverTestCase getInstance() {
        if (sInstance == null) {
            synchronized (BroadcastReceiverTestCase.class) {
                if (sInstance == null) {
                    sInstance = new BroadcastReceiverTestCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Framework",
                    "Framework-BroadcastReceiver",
                    "BroadcastReceiver组件",
                    "BroadcastReceiver 是 android.content.BroadcastReceiver 的封装，但区别在于 mPaaS 框架采用了 android.support.v4.content.LocalBroadcastManager 来注册和反注册 BroadcastReciever，因此，这些广播仅用于当前应用程序内部，除此之外，mPaas框架内部内置了一系列的广播事件，供使用者监听。",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // 手动检测 do nothing
    }
}
