package com.mpaas.demo.framework.testcase;

import com.alipay.mobile.framework.LauncherApplicationAgent;
import com.mpaas.diagnose.DiagnoseService;
import com.mpaas.diagnose.IDiagnoseController;
import com.mpaas.diagnose.ILogListener;

import java.util.LinkedList;

import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;

public class FrameworkDiagnoseController implements IDiagnoseController {

    public static DiagnoseService service;

    @Override
    public void init() {
        service = LauncherApplicationAgent.getInstance().getMicroApplicationContext().findServiceByInterface(DiagnoseService.class.getName());
        registerTestCase();
        //默认为失败，后面检测的过程中，若检测到了相应的log会更新为成功状态
        FrameworkDiagnoseController.service.reportCase(ActivityApplicationTestCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "");
        FrameworkDiagnoseController.service.reportCase(ServiceTestCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "");
        FrameworkDiagnoseController.service.reportCase(BroadcastReceiverTestCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "");
        FrameworkDiagnoseController.service.reportCase(PipelineTestCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "");
    }

    @Override
    public LinkedList<ILogListener> registerLogListeners() {
        LinkedList<ILogListener> listeners = new LinkedList<>();
        listeners.add(new FrameworkLogListener());
        return listeners;
    }

    @Override
    public void runAllCase() {
    }

    private void registerTestCase() {
        service.registerCase(ActivityApplicationTestCase.getInstance().getCaseInfo());
        service.registerCase(ServiceTestCase.getInstance().getCaseInfo());
        service.registerCase(BroadcastReceiverTestCase.getInstance().getCaseInfo());
        service.registerCase(PipelineTestCase.getInstance().getCaseInfo());
        service.registerCase(UtdIdTestCase.getInstance().getCaseInfo());
    }
}
