package com.mpaas.demo.framework.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.alipay.mobile.common.logging.api.LoggerFactory;
import com.mpaas.diagnose.ILogListener;

import java.util.List;

import static com.alipay.mobile.common.logging.api.LogEvent.Level.DEBUG_INT;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class FrameworkLogListener implements ILogListener {
    @Override
    public String getTag() {
        return "mpaas_demo_framework";
    }

    @Override
    public List<String> getProcesses() {
        return null;
    }

    @Override
    public boolean canFuzzyMatch() {
        return false;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {
        if (logEvent.getLevel().levelInt == DEBUG_INT) {
            if (logEvent.getMessage().contains("ActivityApplication success")) {
                FrameworkDiagnoseController.service.reportCase(ActivityApplicationTestCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                LoggerFactory.getTraceLogger().debug(Constant.TAG, "ActivityApplicationTestCase report success");
            } else if (logEvent.getMessage().contains("Service success")) {
                FrameworkDiagnoseController.service.reportCase(ServiceTestCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                LoggerFactory.getTraceLogger().debug(Constant.TAG, "ServiceTestCase report success");
            } else if (logEvent.getMessage().contains("BroadcastReceiver success")) {
                FrameworkDiagnoseController.service.reportCase(BroadcastReceiverTestCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                LoggerFactory.getTraceLogger().debug(Constant.TAG, "BroadcastReceiverTestCase report success");
            } else if (logEvent.getMessage().contains("PipeLine success")) {
                FrameworkDiagnoseController.service.reportCase(PipelineTestCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                LoggerFactory.getTraceLogger().debug(Constant.TAG, "PipelineTestCase report success");
            } else if (logEvent.getMessage().contains("Utdid success")) {
                FrameworkDiagnoseController.service.reportCase(UtdIdTestCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                LoggerFactory.getTraceLogger().debug(Constant.TAG, "UtdIdTestCase report success");
            }
        }
    }
}
