package com.mpaas.demo.framework.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by mengfei on 2019/2/26.
 */

public class PipelineTestCase implements ICase {
    private static PipelineTestCase sInstance;
    private CaseInfo mCaseInfo;

    private PipelineTestCase() {
    }

    public static PipelineTestCase getInstance() {
        if (sInstance == null) {
            synchronized (PipelineTestCase.class) {
                if (sInstance == null) {
                    sInstance = new PipelineTestCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Framework",
                    "Framework-Pipeline",
                    "PipelineTestCase组件",
                    "mPaaS 框架有一个比较明显的启动过程，Pipeline 机制允许业务线将自己的运行逻辑封装成 Runnable 放到 Pipeline。框架在适当的阶段启动适当的 Pipeline。",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // 手动检测 do nothing
    }
}
