package com.mpaas.demo.framework.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by mengfei on 2019/2/26.
 */

public class ServiceTestCase implements ICase {
    private static ServiceTestCase sInstance;
    private CaseInfo mCaseInfo;

    private ServiceTestCase() {
    }

    public static ServiceTestCase getInstance() {
        if (sInstance == null) {
            synchronized (ServiceTestCase.class) {
                if (sInstance == null) {
                    sInstance = new ServiceTestCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Framework",
                    "Framework-Service",
                    "Service组件",
                    "Service组件用于将一些逻辑以服务的形式提供出来，供其他模块使用",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // 手动检测 do nothing
    }
}
