package com.mpaas.demo.hotpatch;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import com.alipay.mobile.antui.basic.AUButton;
import com.alipay.mobile.antui.basic.AUTitleBar;
import com.alipay.mobile.antui.basic.AUToast;
import com.alipay.mobile.framework.app.ui.BaseActivity;
import com.mpaas.demo.sharedres.MenuPopupWindow;
import com.mpaas.hotpatch.adapter.api.MPHotpatch;

public class HotpatchActivity extends BaseActivity {
    private AUButton mHotpatchNeedHotpatchBtn;
    private AUButton mHotpatchTriggerHotpatchBtn;
    private AUTitleBar mTitle;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_hotpatch);
        findView();
        initView();
    }

    private void findView() {
        mTitle = ((AUTitleBar) findViewById(R.id.title_atb));
        mHotpatchNeedHotpatchBtn = (AUButton) findViewById(R.id.hotpatch_need_hotpatch_btn);
        mHotpatchTriggerHotpatchBtn = (AUButton) findViewById(R.id.hotpatch_trigger_hotpatch_btn);
    }

    private void initView() {
        mTitle.setTitleText(getString(R.string.hotpatch), (int) getResources().getDimension(com.mpaas.demo.sharedres.R.dimen.text_size)
                , getResources().getColor(com.mpaas.demo.sharedres.R.color.title_color));
        mTitle.getRightButtonIconView().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                MenuPopupWindow popupWindow = new MenuPopupWindow(HotpatchActivity.this);
                popupWindow.showAsDropDown(mTitle.getRightButtonIconView(), 0, 0);
            }
        });
        mHotpatchNeedHotpatchBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                // 以下代码为需要被热修复的部分
                String content = "异常，当前点击事件未被热修复";
//                String content = "当前点击事件已被热修复";
                AUToast.makeToast(HotpatchActivity.this, com.alipay.mobile.antui.R.drawable.toast_false, content, Toast.LENGTH_SHORT).show();
            }
        });
        mHotpatchTriggerHotpatchBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                MPHotpatch.init();
            }
        });
    }
}
