package com.mpaas.demo.hotpatch.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by mengfei on 2019/2/26.
 */

public class ApplyHotpatchTestCase implements ICase {
    private static ApplyHotpatchTestCase sInstance;
    private CaseInfo mCaseInfo;

    private ApplyHotpatchTestCase() {
    }

    public static ApplyHotpatchTestCase getInstance() {
        if (sInstance == null) {
            synchronized (ApplyHotpatchTestCase.class) {
                if (sInstance == null) {
                    sInstance = new ApplyHotpatchTestCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Hotpatch",
                    "Hotpatch-apply",
                    "应用热修复",
                    "杀掉进程，会加载热修复包，完成热修复",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        //do nothing
    }
}
