package com.mpaas.demo.hotpatch.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

public class DownloadPatchTestCase implements ICase {
    private static DownloadPatchTestCase sInstance;
    private CaseInfo mCaseInfo;

    private DownloadPatchTestCase() {
    }

    public static DownloadPatchTestCase getInstance() {
        if (sInstance == null) {
            synchronized (DownloadPatchTestCase.class) {
                if (sInstance == null) {
                    sInstance = new DownloadPatchTestCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Hotpatch",
                    "Hotpatch-download",
                    "下载能力",
                    "触发热修复包的下载",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        //do nothing
    }
}