package com.mpaas.demo.hotpatch.testcase;

import com.mpaas.diagnose.DiagnoseService;
import com.mpaas.diagnose.IDiagnoseController;
import com.mpaas.diagnose.ILogListener;
import com.mpaas.framework.adapter.api.MPFramework;

import java.util.LinkedList;

public class HotpatchDiagnoseController implements IDiagnoseController {

    public static DiagnoseService service;

    @Override
    public void init() {
        service = MPFramework.getExternalService(DiagnoseService.class.getName());
        registerCases();
    }

    @Override
    public LinkedList<ILogListener> registerLogListeners() {
        LinkedList<ILogListener> listeners = new LinkedList<>();
        listeners.add(new ApplyHotpatchLogListener());
        listeners.add(new DynamicReleaseLogListener());
        return listeners;
    }

    @Override
    public void runAllCase() {
        DownloadPatchTestCase.getInstance().run();
    }

    private void registerCases() {
        service.registerCase(DownloadPatchTestCase.getInstance().getCaseInfo());
        service.registerCase(ApplyHotpatchTestCase.getInstance().getCaseInfo());
    }
}
