package com.mpaas.demo.launcher;

import com.mpaas.diagnose.IDiagnoseCheckList;
import com.mpaas.diagnose.IDiagnoseController;

import java.util.LinkedList;

public class DefaultDiagnoseCheckList implements IDiagnoseCheckList {

    @Override
    public LinkedList<IDiagnoseController> getDiagnoseControllers() {
        LinkedList<IDiagnoseController> list = new LinkedList<>();
        // 加入 framework
        reflectAndAdd(list, "com.mpaas.demo.framework.testcase.FrameworkDiagnoseController");
        // 加入 mgs
        reflectAndAdd(list, "com.mpaas.demo.rpc.testcase.RpcDiagnoseController");
        // 加入 mas
        reflectAndAdd(list, "com.mpaas.demo.analytics.testcase.AnalyticsDiagnoseController");
        // 加入 upgrade
        reflectAndAdd(list, "com.mpaas.demo.upgrade.testcase.UpgradeDiagnoseController");
        // 加入 hotpatch
        reflectAndAdd(list, "com.mpaas.demo.hotpatch.testcase.HotpatchDiagnoseController");
        // 加入 config service
        reflectAndAdd(list, "com.mpaas.demo.configservice.testcase.ConfigServiceDiagnoseController");
        // 加入 mps
        reflectAndAdd(list, "com.mpaas.demo.push.testcase.PushDiagnoseController");
        // 加入 mss
        reflectAndAdd(list, "com.mpaas.demo.sync.testcase.SyncDiagnoseController");
        // 加入 nebula
        reflectAndAdd(list, "com.mpaas.demo.nebula.testcase.NebulaDiagnoseController");
        // 加入 storage
        reflectAndAdd(list, "com.mpaas.demo.storage.testcase.StorageDiagnoseController");
        // 加入 lbs
        reflectAndAdd(list, "com.mpaas.demo.lbs.testcase.LbsDiagnoseController");
        return list;
    }

    private void reflectAndAdd(LinkedList<IDiagnoseController> list, String className) {
        IDiagnoseController diagnoseController = null;
        try {
            Class clazz = Class.forName(className);
            diagnoseController = (IDiagnoseController) clazz.newInstance();
        } catch (Exception e) {
            diagnoseController = null;
        }
        if (null != diagnoseController) {
            list.add(diagnoseController);
        }
    }
}
