package com.mpaas.demo.launcher.expandview;

import android.content.Context;
import android.util.AttributeSet;
import android.view.LayoutInflater;

import com.alipay.mobile.antui.basic.AUImageView;
import com.alipay.mobile.antui.basic.AURelativeLayout;
import com.alipay.mobile.antui.basic.AUTextView;
import com.alipay.mobile.antui.iconfont.AUIconView;
import com.mpaas.demo.launcher.R;

/**
 * Created by ciwei on 18/6/17.
 */

public class ExpaGroupItem extends AURelativeLayout {

    private AUTextView groupTitle;
    private AUImageView groupIcon;
    private AUIconView groupArrow;

    public ExpaGroupItem(Context context) {
        super(context);
        init(context);
    }

    public ExpaGroupItem(Context context, AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }

    public ExpaGroupItem(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init(context);
    }

    private void init(Context context) {
        LayoutInflater.from(context).inflate(R.layout.item_expa_group, this, true);
        groupTitle = (AUTextView) findViewById(R.id.group_title);
        groupIcon = (AUImageView) findViewById(R.id.group_icon);
        groupArrow = (AUIconView) findViewById(R.id.group_arrow);
    }

    public void setInfo(ComponentModel model) {
        groupTitle.setText(model.title);
        if (model.iconResId > 0) {
            groupIcon.setVisibility(VISIBLE);
            groupIcon.setImageResource(model.iconResId);
        } else {
            groupIcon.setVisibility(GONE);
        }
    }

    public void setArrowVisible(boolean isVisible) {
        groupArrow.setVisibility(isVisible ? VISIBLE : GONE);
    }
}
