package com.mpaas.demo.lbs.testcase;

import android.Manifest;
import android.app.Activity;
import android.content.pm.PackageManager;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;

import com.alipay.mobile.common.lbs.LBSLocation;
import com.alipay.mobile.common.lbs.LBSLocationListener;
import com.alipay.mobile.common.lbs.LBSLocationManagerProxy;
import com.alipay.mobile.framework.LauncherApplicationAgent;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

import java.util.concurrent.TimeUnit;

/**
 * Created by xingcheng on 2019/3/5.
 */

public class CheckPermissionCase implements ICase {

    private static CheckPermissionCase sInstance;
    private CaseInfo mCaseInfo;

    private CheckPermissionCase() {
    }

    public static CheckPermissionCase getInstance() {
        if (sInstance == null) {
            synchronized (CheckPermissionCase.class) {
                if (sInstance == null) {
                    sInstance = new CheckPermissionCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Lbs",
                    "Lbs-000000",
                    "检测定位权限",
                    "自动检测定位权限",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        Activity activity = LauncherApplicationAgent.getInstance().getMicroApplicationContext().getTopActivity().get();
        if (activity == null) {
            return;
        }
        if (ContextCompat.checkSelfPermission(activity, Manifest.permission.ACCESS_FINE_LOCATION)
                != PackageManager.PERMISSION_GRANTED) {
            LbsDiagnoseController.service.reportCase(mCaseInfo, CaseInfo.RESULT_CODE_FAIL, "未获取定位权限");
            ActivityCompat.requestPermissions(activity,
                    new String[]{Manifest.permission.ACCESS_FINE_LOCATION},
                    1);
        } else {
            LbsDiagnoseController.service.reportCase(mCaseInfo, CaseInfo.RESULT_CODE_SUCCESS, "已获取定位权限");
        }
    }
}
