package com.mpaas.demo.nebula;

import com.alipay.mobile.common.logging.api.LoggerFactory;
import com.alipay.mobile.nebula.provider.H5ResProvider;
import com.alipay.mobile.nebula.util.H5Utils;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import static com.mpaas.demo.nebula.ResourceCache.TAG;

public class GapResProvider implements H5ResProvider {

    @Override
    public InputStream getResource(String sourceUrl) {
        if (isCache(sourceUrl)) {
            if (ResourceCache.contains(sourceUrl)) {
                try {
                    InputStream inputStream = ResourceCache.getResource(sourceUrl);
                    if (null == inputStream) {
                        LoggerFactory.getTraceLogger().debug(TAG, "File null: " + sourceUrl);
                        return new URL(sourceUrl).openStream();
                    }
                    LoggerFactory.getTraceLogger().debug(TAG, "getResource: " + sourceUrl);
                    return inputStream;
                } catch (Exception e) {
                }
            }
        } else {
            try {
                return new URL(sourceUrl).openStream();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    @Override
    public boolean contains(String sourceUrl) {
        if (isCache(sourceUrl)) {
            if (ResourceCache.contains(sourceUrl)) {
                LoggerFactory.getTraceLogger().debug(TAG, "contains: " + sourceUrl);
                return true;
            } else {
                ResourceCache.download(sourceUrl);
                return false;
            }
        }
        return false;
    }

    private boolean isCache(String url) {
        return url.startsWith("https://mbanktest.95559.com.cn:8717")
                && (
                url.endsWith(".js")
                                ||url.endsWith(".jpg")
//                                ||url.endsWith(".html")
                                ||url.endsWith(".gif")
                                ||url.endsWith(".png")
//                                ||url.endsWith(".css")
        )
                ;
    }

    public static void register() {
        H5Utils.setProvider(H5ResProvider.class.getName(), new GapResProvider());
    }
}
