package com.mpaas.demo.nebula;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

/**
 * Created by Administrator on 2016/9/14.
 */
public class HttpDownloader {
    String line = null;
    StringBuffer strBuffer = new StringBuffer();
    BufferedReader bufferReader = null;


    //可以下载任意文件，例如MP3，并把文件存储在制定目录（-1：下载失败，0：下载成功，1：文件已存在）
    public int downloadFiles(String urlStr, String path, String fileName) {
        HttpsURLConnection urlConn = null;
        InputStream inputStream = null;
        try {
            FileUtils fileUtils = new FileUtils();
            if (fileUtils.isFileExist(fileName, path)) {
                return 1;
            }
            URL url = new URL(urlStr);
            //创建一个HTTP链接
            urlConn = (HttpsURLConnection) url.openConnection();

            SSLContext sslContext = HttpsUtil.getSSLContextWithoutCer();
            if (sslContext != null) {
                SSLSocketFactory sslSocketFactory = sslContext.getSocketFactory();
                urlConn.setDefaultSSLSocketFactory(sslSocketFactory);
                urlConn.setHostnameVerifier(HttpsUtil.hostnameVerifier);
            }
            inputStream = urlConn.getInputStream();
            File resultFile = fileUtils.write2SDFromInput(fileName, path, inputStream);
            if (resultFile == null) return -1;
        } catch (Exception e) {
            System.out.println("读写数据异常:" + e);
            return -1;
        } finally {
            if (null != urlConn) {
                urlConn.disconnect();
            }
            if (null != inputStream) {
                try {
                    inputStream.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return 0;
    }


    static class HttpsUtil {
        public static SSLContext getSSLContextWithoutCer() throws NoSuchAlgorithmException, KeyManagementException {
            // 实例化SSLContext
            // 这里参数可以用TSL 也可以用SSL
            SSLContext sslContext = SSLContext.getInstance("SSL");
            sslContext.init(null, new TrustManager[]{trustManagers}, new SecureRandom());
            return sslContext;

        }

        public static TrustManager trustManagers = new X509TrustManager() {

            @Override
            public void checkClientTrusted(X509Certificate[] chain, String authType) throws CertificateException {
            }

            @Override
            public void checkServerTrusted(X509Certificate[] chain, String authType) throws CertificateException {

            }

            @Override
            public X509Certificate[] getAcceptedIssuers() {
                return new X509Certificate[0];
            }
        };

        /**
         * 验证主机名
         */
        public static HostnameVerifier hostnameVerifier = new HostnameVerifier() {

            @Override
            public boolean verify(String hostname, SSLSession session) {
                // TODO Auto-generated method stub
                return true;
            }
        };
    }
}

