package com.mpaas.demo.nebula;

import android.content.Intent;
import android.os.Bundle;

import com.alipay.mobile.framework.app.ActivityApplication;
import com.mpaas.framework.adapter.api.MPFramework;


public class NebulaApp extends ActivityApplication {
    private Bundle mParam;

    @Override
    public String getEntryClassName() {
        return null;
    }

    @Override
    protected void onCreate(Bundle bundle) {
        mParam = bundle;
    }

    @Override
    protected void onStart() {
        doStartApp(mParam);
    }

    @Override
    protected void onRestart(Bundle bundle) {
        mParam = bundle;
        doStartApp(mParam);
    }


    @Override
    protected void onStop() {

    }

    @Override
    protected void onDestroy(Bundle bundle) {

    }

    private void doStartApp(Bundle params) {
        String type = params.getString("type");
        if ("online".equalsIgnoreCase(type)) {
            launchOnlineActivity();
        } else if ("h5app".equalsIgnoreCase(type)) {
            Intent intent = new Intent(getMicroApplicationContext().getApplicationContext(), NebulaAppActivity.class);
            getMicroApplicationContext().startActivity(this, intent);
        } else if ("customize".equalsIgnoreCase(type)) {
            Intent intent = new Intent(getMicroApplicationContext().getApplicationContext(), CustomizeActivity.class);
            getMicroApplicationContext().startActivity(this, intent);
        } else if ("mini".equalsIgnoreCase(type)) {
            // 启动小程序demo
            MPFramework.getMicroApplicationContext()
                    .startApp(null, "2018080616290001", null);
        } else if ("others".equalsIgnoreCase(type)) {
            //启动其他功能点的demo
            Intent intent = new Intent(getMicroApplicationContext().getApplicationContext(), OtherFunctionActivity.class);
            getMicroApplicationContext().startActivity(this, intent);
        }
    }

    private void launchOnlineActivity() {
        Intent intent = new Intent(getMicroApplicationContext().getApplicationContext(), MainActivity.class);
        getMicroApplicationContext().startActivity(this, intent);
    }

}
