package com.mpaas.demo.nebula;

import android.os.Bundle;
import android.view.View;

import com.alipay.mobile.antui.basic.AUTitleBar;
import com.alipay.mobile.antui.basic.AUToast;
import com.alipay.mobile.framework.app.ui.BaseActivity;
import com.mpaas.demo.sharedres.MenuPopupWindow;
import com.mpaas.nebula.adapter.api.MPNebula;
import com.mpaas.nebula.adapter.api.MpaasNebulaUpdateCallback;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by omg on 2018/7/23.
 */

public class NebulaAppActivity extends BaseActivity implements View.OnClickListener {

    private static final String TAG = "NebulaAppActivity";
    private AUTitleBar mTitle;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_nebula_app);
        mTitle = (AUTitleBar) findViewById(R.id.titlebar);
        findViewById(R.id.btn_verify_setting).setOnClickListener(this);
        findViewById(R.id.btn_open_app).setOnClickListener(this);
        findViewById(R.id.btn_update_app).setOnClickListener(this);
        findViewById(R.id.btn_update_specific_app).setOnClickListener(this);
        mTitle.setTitleText(getString(R.string.nebula_app), (int) getResources().getDimension(com.mpaas.demo.sharedres.R.dimen.text_size)
                , getResources().getColor(com.mpaas.demo.sharedres.R.color.title_color));
        mTitle.getRightButtonIconView().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                MenuPopupWindow popupWindow = new MenuPopupWindow(NebulaAppActivity.this);
                popupWindow.showAsDropDown(mTitle.getRightButtonIconView(), 0, 0);
            }
        });
    }

    private void enableAppVerification() {
        MPNebula.enableAppVerification("MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwn7LQcdQYrw44Sr8hAvM" +
                "3og1mxB3YkfGrBXuWHRWGEbuL2yIOxVaJZpcJsC48leUHxlqrHk1FnaLuWbeCSiS" +
                "EuXLqzOT/w8Vtfl9GPyzP/h0VWRITlV5tMX67U9urxVK6dq1GJzGwHnprFFjebey" +
                "IukQUAOQMPTWLFbdPPIvaCtU1LCYqHbj23ANu8h+xWV9ts83FWhJ1WKNFYrjEmGU" +
                "x9M1YDsbJUzcpC7RByWVOg/ZHAYPHBrVC07B+VG4219q8AI/ijJ9AhK5T8yxdz4k" +
                "pcL9BFzk8BSs4eSCZ10e6Y3gVybO7iNac/1a2EGfFNz9EUJ8/kxccZfpO01DPwXu" +
                "NQIDAQAB");
        AUToast.makeToast(NebulaAppActivity.this, R.string.setting_success, 2000).show();
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btn_verify_setting:
                enableAppVerification();
                break;
            case R.id.btn_open_app:
                openApp("90000000");
                break;
            case R.id.btn_update_app:
                updateAllApps();
                break;
            case R.id.btn_update_specific_app:
                updateApp("90000000");
                break;
        }
    }

    private void openApp(String appId) {
        MPNebula.startApp(appId);
    }

    private void updateApp(String appid) {
        Map<String, String> appMap = new HashMap<>();
        //key为appid，value为version，version可以通过H5AppProvider获取，startUpdateApp内部会自动读取version，所以这里可以传空
        appMap.put(appid, "");
        MPNebula.updateApp(appMap,new MpaasNebulaUpdateCallback(){
            @Override
            public void onResult(final boolean success, final boolean isLimit) {
                super.onResult(success, isLimit);
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        AUToast.makeToast(NebulaAppActivity.this,
                                success ? R.string.update_success : R.string.update_failure, 2000).show();
                    }
                });
            }
        },true);
    }

    private void updateAllApps() {
        MPNebula.updateAllApp(new MpaasNebulaUpdateCallback(){
            @Override
            public void onResult(final boolean success, final boolean isLimit) {
                super.onResult(success, isLimit);
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        AUToast.makeToast(NebulaAppActivity.this,
                                success ? R.string.update_success : R.string.update_failure, 2000).show();
                    }
                });
            }
        });
    }
}
