package com.mpaas.demo.nebula.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;
import com.mpaas.nebula.adapter.api.MPNebula;
import com.mpaas.nebula.adapter.api.MpaasNebulaUpdateCallback;

import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class AppUpdateCase implements ICase {
    private static AppUpdateCase sInstance;
    private CaseInfo mCaseInfo;

    private AppUpdateCase() {
    }

    public static AppUpdateCase getInstance() {
        if (sInstance == null) {
            synchronized (AppUpdateCase.class) {
                if (sInstance == null) {
                    sInstance = new AppUpdateCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000000",
                    "检测离线包更新功能",
                    "自动检测离线包更新功能",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        MPNebula.updateAllApp(new MpaasNebulaUpdateCallback() {
            public void onResult(boolean success, boolean isLimit) {
                if (success) {
                    NebulaDiagnoseController.service.reportCase(AppUpdateCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                } else {
                    NebulaDiagnoseController.service.reportCase(AppUpdateCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "更新失败");
                }
            }
        });
    }
}