package com.mpaas.demo.nebula.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.mpaas.diagnose.ILogListener;

import java.util.List;

import static com.alipay.mobile.common.logging.api.LogEvent.Level.DEBUG_INT;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class H5PackageParserLogListener implements ILogListener {
    @Override
    public String getTag() {
        return "H5PackageParser";
    }

    @Override
    public List<String> getProcesses() {
        return null;
    }

    @Override
    public boolean canFuzzyMatch() {
        return false;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {
        if (logEvent.getLevel().levelInt == DEBUG_INT) {
            // 检测验签是否开启
            if(logEvent.getMessage().contains("parsePackage isNeedVerifyFromConfig")){
                if(logEvent.getMessage().endsWith("false")){
                    NebulaDiagnoseController.service.reportCase(VerifyCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "未开启验签");
                }
            }
            // 验签是否成功
            if (logEvent.getMessage().contains("signKey")
                    && logEvent.getMessage().contains("signValue")
                    && logEvent.getMessage().contains("result:")) {
                String[] temp = logEvent.getMessage().split("result:");
                if (temp.length > 1 && null != temp[1]) {
                    String result = temp[1];
                    if (result.startsWith("true")) {
                        NebulaDiagnoseController.service.reportCase(VerifyCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                    } else {
                        NebulaDiagnoseController.service.reportCase(VerifyCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, logEvent.getMessage());
                    }
                }
            }
        }
    }
}
