package com.mpaas.demo.nebula.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.mpaas.diagnose.ILogListener;

import java.util.List;

import static com.alipay.mobile.common.logging.api.LogEvent.Level.DEBUG_INT;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class H5PageDataLogListener implements ILogListener {
    @Override
    public String getTag() {
        return "H5PageData";
    }

    @Override
    public List<String> getProcesses() {
        return null;
    }

    @Override
    public boolean canFuzzyMatch() {
        return false;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {
        if (logEvent.getLevel().levelInt == DEBUG_INT) {
            // 检测 UC 内核
            if (logEvent.getMessage().contains("setWebViewType")) {
                if (logEvent.getMessage().contains("UCWebView")) {
                    NebulaDiagnoseController.service.reportCase(UCCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                } else {
                    NebulaDiagnoseController.service.reportCase(UCCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "不是 UC 内核\n" + logEvent.getMessage());
                }
            }
        }
    }
}
