package com.mpaas.demo.nebula.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.mpaas.diagnose.ILogListener;

import java.util.List;

import static com.alipay.mobile.common.logging.api.LogEvent.Level.DEBUG_INT;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class H5WebViewLogListener implements ILogListener {
    @Override
    public String getTag() {
        return "H5WebView";
    }

    @Override
    public List<String> getProcesses() {
        return null;
    }

    @Override
    public boolean canFuzzyMatch() {
        return true;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {
        if (logEvent.getLevel().levelInt == DEBUG_INT) {
            if (logEvent.getMessage().contains("set final ua ")) {
                if (logEvent.getMessage().contains(" AlipayClient/mPaaS")) {
                    NebulaDiagnoseController.service.reportCase(UACase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "");
                } else {
                    NebulaDiagnoseController.service.reportCase(UACase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "不是指定 UA：" + logEvent.getMessage());
                }
            }
        }
    }
}
