package com.mpaas.demo.nebula.testcase;

import com.alipay.mobile.nebula.appcenter.model.AppInfo;
import com.alipay.mobile.nebula.provider.H5AppProvider;
import com.alipay.mobile.nebula.util.H5Utils;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class LoadOfflineNebulaCase implements ICase {
    private static LoadOfflineNebulaCase sInstance;
    private CaseInfo mCaseInfo;

    private LoadOfflineNebulaCase() {
    }

    public static LoadOfflineNebulaCase getInstance() {
        if (sInstance == null) {
            synchronized (LoadOfflineNebulaCase.class) {
                if (sInstance == null) {
                    sInstance = new LoadOfflineNebulaCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000011",
                    "检测是否可以预置离线包",
                    "Demo 会在 pipeline 中自动预置离线包，只需要检测对应 log 日志",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        H5AppProvider h5AppProvider = H5Utils.getProvider(H5AppProvider.class.getName());
        if (null != h5AppProvider) {
            String appId = "90000000";
            String version = "1.0.0.6";
            AppInfo appInfo = h5AppProvider.getAppInfo(appId);
            if (null != appInfo) {
                NebulaDiagnoseController.service.reportCase(LoadOfflineNebulaCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "已加载，版本：" + appInfo.version);
            } else {
                NebulaDiagnoseController.service.reportCase(LoadOfflineNebulaCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "未加载");
            }
        }
    }
}
