package com.mpaas.demo.nebula.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

public class OpenH5Case implements ICase {
    private static OpenH5Case sInstance;
    private CaseInfo mCaseInfo;

    private OpenH5Case() {
    }

    public static OpenH5Case getInstance() {
        if (sInstance == null) {
            synchronized (OpenH5Case.class) {
                if (sInstance == null) {
                    sInstance = new OpenH5Case();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000006",
                    "检测打开 H5 页面",
                    "手动检测打开 H5 页面，需要打开一个 id = 90000000 的 H5 应用。",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
