package com.mpaas.demo.nebula.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

public class OpenTinyCase implements ICase {
    private static OpenTinyCase sInstance;
    private CaseInfo mCaseInfo;

    private OpenTinyCase() {
    }

    public static OpenTinyCase getInstance() {
        if (sInstance == null) {
            synchronized (OpenTinyCase.class) {
                if (sInstance == null) {
                    sInstance = new OpenTinyCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000007",
                    "检测打开小程序",
                    "手动检测打开小程序，需要打开一个 id = 2018080616290001 的小程序。",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
