package com.mpaas.demo.nebula.testcase;

import com.alipay.mobile.h5container.api.H5Plugin;
import com.alipay.mobile.nebula.config.H5PluginConfig;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;
import com.mpaas.nebula.adapter.api.MPNebula;

public class RegisterPluginCase implements ICase {
    private static RegisterPluginCase sInstance;
    private CaseInfo mCaseInfo;

    private RegisterPluginCase() {
    }

    public static RegisterPluginCase getInstance() {
        if (sInstance == null) {
            synchronized (RegisterPluginCase.class) {
                if (sInstance == null) {
                    sInstance = new RegisterPluginCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000003",
                    "检测注册插件",
                    "自动检测注册插件是否成功",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        MPNebula.registerH5Plugin(
                "com.mpaas.demo.nebula.MyJSApiPlugin",
                "com-mpaas-demo-nebula-nebula",
                "page",
                new String[]{"myapi1","myapi2"});
    }
}
