package com.mpaas.demo.nebula.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

public class TinyAppCommonResCase implements ICase {
    private static TinyAppCommonResCase sInstance;
    private CaseInfo mCaseInfo;

    private TinyAppCommonResCase() {
    }

    public static TinyAppCommonResCase getInstance() {
        if (sInstance == null) {
            synchronized (TinyAppCommonResCase.class) {
                if (sInstance == null) {
                    sInstance = new TinyAppCommonResCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000005",
                    "检测小程序公共资源包是否预置",
                    "手动检测小程序公共资源包是否预置，需要打开一个小程序",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // 手动检测 do nothing
    }
}
