package com.mpaas.demo.nebula.testcase;

import com.alipay.mobile.nebula.provider.H5UaProvider;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;
import com.mpaas.nebula.adapter.api.MPNebula;

public class UACase implements ICase {
    private static UACase sInstance;
    private CaseInfo mCaseInfo;

    private UACase() {
    }

    public static UACase getInstance() {
        if (sInstance == null) {
            synchronized (UACase.class) {
                if (sInstance == null) {
                    sInstance = new UACase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000004",
                    "检测是否可以设置指定 UA",
                    "首先运行上面自动化 testcase，设置指定 UA，然后手动打开一个 H5 页面，检测 UA 是否已经设置指定值",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        MPNebula.setUa(new H5UaProvider() {
            @Override
            public String getUa(String s) {
                return s+" AlipayClient/mPaaS";
            }
        });

    }
}
