package com.mpaas.demo.nebula.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

public class UCCase implements ICase {
    private static UCCase sInstance;
    private CaseInfo mCaseInfo;

    private UCCase() {
    }

    public static UCCase getInstance() {
        if (sInstance == null) {
            synchronized (UCCase.class) {
                if (sInstance == null) {
                    sInstance = new UCCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000001",
                    "检测 UC 内核",
                    "手动检测 UC 内核，需要打开一个 H5 应用或是在线页面。",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // 手动检测 do nothing
    }
}
