package com.mpaas.demo.nebula.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

public class VerifyCase implements ICase {
    private static VerifyCase sInstance;
    private CaseInfo mCaseInfo;

    private VerifyCase() {
    }

    public static VerifyCase getInstance() {
        if (sInstance == null) {
            synchronized (VerifyCase.class) {
                if (sInstance == null) {
                    sInstance = new VerifyCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Nebula",
                    "Nebula-000002",
                    "验签是否通过",
                    "需要打开验签开关，并手动打开一个 H5 应用或是在线页面。",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        // 手动检测 do nothing
    }
}
