package com.mpaas.demo.push.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.alipay.mobile.common.logging.api.LoggerFactory;
import com.mpaas.diagnose.ILogListener;

import java.util.ArrayList;
import java.util.List;

import static com.mpaas.demo.push.testcase.PushDiagnoseController.TAG;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;

/**
 * Created by larry.cl.
 */
public class PushInitCaseLogListener implements ILogListener {
    @Override
    public String getTag() {
        return "mpush14";
    }

    @Override
    public List<String> getProcesses() {
        ArrayList<String> list = new ArrayList<>();
        list.add("push");
        return list;
    }

    @Override
    public boolean canFuzzyMatch() {
        return false;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {
        LoggerFactory.getTraceLogger().error(TAG, logEvent.getMessage());
        if (logEvent.getMessage().contains("huawei client onConnectionFailed")) {
            PushDiagnoseController.service.reportCase(PushInitAndPushCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "华为渠道注册失败\n" + logEvent.getMessage());
        }
    }
}
