package com.mpaas.demo.rpc.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class ConfigCase implements ICase {

    private static ConfigCase sInstance;
    private CaseInfo mCaseInfo;

    private ConfigCase() {

    }

    public static ConfigCase getInstance() {
        if (sInstance == null) {
            synchronized (ConfigCase.class) {
                if (sInstance == null) {
                    sInstance = new ConfigCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Rpc",
                    "Rpc-000003",
                    "检测Rpc配置相关功能",
                    "自动检测Rpc配置相关功能",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {

    }
}
