package com.mpaas.demo.rpc.testcase;

import com.alipay.mobile.common.rpc.RpcException;
import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

import static com.mpaas.demo.rpc.testcase.RpcDiagnoseController.demoClient;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_FAIL;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

/**
 * Created by larry.cl.
 */
public class ExceptionCase implements ICase {

    private static ExceptionCase sInstance;
    private CaseInfo mCaseInfo;

    private ExceptionCase() {

    }

    public static ExceptionCase getInstance() {
        if (sInstance == null) {
            synchronized (ExceptionCase.class) {
                if (sInstance == null) {
                    sInstance = new ExceptionCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Rpc",
                    "Rpc-000002",
                    "检测Rpc请求异常功能",
                    "自动检测Rpc请求异常功能",
                    false
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
        try {
            String result = demoClient.exceptionGet();
            if (result == null) {
                RpcDiagnoseController.service.reportCase(ExceptionCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "异常请求处理成功");
            }
        } catch (RpcException e) {
            RpcDiagnoseController.service.reportCase(ExceptionCase.getInstance().getCaseInfo(), RESULT_CODE_FAIL, "异常请求处理失败");
        }
    }

}
