package com.mpaas.demo.storage.testcase;

import com.mpaas.diagnose.DiagnoseService;
import com.mpaas.diagnose.IDiagnoseController;
import com.mpaas.diagnose.ILogListener;
import com.mpaas.framework.adapter.api.MPFramework;

import java.util.LinkedList;

public class StorageDiagnoseController implements IDiagnoseController {

    public static final String GROUP_ID = "com_mpaas_demo_storage";
    public static DiagnoseService service;

    @Override
    public void init() {
        service = MPFramework.getExternalService(DiagnoseService.class.getName());
        registerDBStorageCase();
        registerKVStorageCase();
        registerFileStorageCase();
    }

    @Override
    public LinkedList<ILogListener> registerLogListeners() {
        LinkedList<ILogListener> listeners = new LinkedList<>();
        return listeners;
    }

    @Override
    public void runAllCase() {
        try {
            DBStorageCase.getInstance().run();
            Thread.sleep(1000);
            KVStorageCase.getInstance().run();
            Thread.sleep(1000);
            FileStorageCase.getInstance().run();
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    private void registerDBStorageCase() {
        service.registerCase(DBStorageCase.getInstance().getCaseInfo());
    }

    private void registerKVStorageCase() {
        service.registerCase(KVStorageCase.getInstance().getCaseInfo());
    }

    private void registerFileStorageCase() {
        service.registerCase(FileStorageCase.getInstance().getCaseInfo());
    }
}
