package com.mpaas.demo.sync;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import com.alipay.mobile.common.logging.api.LoggerFactory;
import com.alipay.mobile.framework.service.common.TaskScheduleService;
import com.mpaas.mas.adapter.api.MPLogger;
import com.mpaas.mss.adapter.api.MPSync;

/**
 * Created by larry.cl.
 */
public class UserBasedSyncActivity extends BaseSyncActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    protected void fetchSyncData(final String data) {
        UserBasedSyncActivity.this.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(UserBasedSyncActivity.this, UserBasedSyncActivity.this.getString(R.string.sync_uidData) + data
                        , Toast.LENGTH_SHORT).show();
            }
        });
    }

    @Override
    public void bindViews() {
        super.bindViews();
        mInputUid.setVisibility(View.VISIBLE);
        mInputSessionId.setVisibility(View.VISIBLE);
        mBtnBind.setVisibility(View.VISIBLE);
        mBtnUnBind.setVisibility(View.VISIBLE);
        mUnBindTips.setVisibility(View.VISIBLE);
        mBindTips.setVisibility(View.VISIBLE);
    }

    @Override
    public void init() {
        super.init();
        executeInThread(new Runnable() {
            @Override
            public void run() {
                //具体biz在服务端进行配置
                MPSync.registerBiz("uidSync", mSyncCallback);
                MPSync.registerBiz("uidSyncGlobal", mSyncCallback);
            }
        }, TaskScheduleService.ScheduleType.RPC);
        //本处使用移动分析demo中提供的uid（非必须），统一方便。 也可以使用其他id值
        mInputUid.setText(getUserId());
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btn_bind:
                //绑定用户
                //LongLinkSyncService.getInstance().updateUserInfo(mInputUid.getInputEdit().getText().toString(), mInputSessionId.getInputEdit().getText().toString());
                MPSync.updateUserInfo(mInputSessionId.getInputEdit().getText().toString());
                break;
            case R.id.btn_unbind:
                //解绑定用户
                MPSync.updateUserInfo("");
                break;
            default:
                break;
        }
    }

    //获取移动分析demo中提供的uid
    private String getUserId() {
        String userId = MPLogger.getUserId();
        LoggerFactory.getTraceLogger().debug(TAG, "userId got is : " + userId);
        return userId;
    }
}
