package com.mpaas.demo.sync.testcase;

import com.alipay.mobile.framework.LauncherApplicationAgent;
import com.mpaas.diagnose.DiagnoseService;
import com.mpaas.diagnose.IDiagnoseController;
import com.mpaas.diagnose.ILogListener;
import com.mpaas.framework.adapter.api.MPFramework;
import com.mpaas.mss.adapter.api.MPSync;

import java.util.LinkedList;

/**
 * Created by larry.cl.
 */
public class SyncDiagnoseController implements IDiagnoseController {

    public static final String TAG = "SyncDiagnoseController";
    public static DiagnoseService service;

    @Override
    public void init() {
        service = MPFramework.getExternalService(DiagnoseService.class.getName());
        registerAllCase();
    }

    @Override
    public LinkedList<ILogListener> registerLogListeners() {
        return new LinkedList<>();
    }

    /**
     * 借助sync demo手动测试，同步的消息内容需设置为1
     */
    @Override
    public void runAllCase() {
        MPSync.initialize(LauncherApplicationAgent.getInstance().getApplicationContext());
        OneDeviceSyncCase.getInstance().run();
        AllDevicesSyncCase.getInstance().run();
        OneUserSyncCase.getInstance().run();
        AllUsersSyncCase.getInstance().run();
    }

    private void registerAllCase() {
        service.registerCase(OneDeviceSyncCase.getInstance().getCaseInfo());
        service.registerCase(AllDevicesSyncCase.getInstance().getCaseInfo());
        service.registerCase(OneUserSyncCase.getInstance().getCaseInfo());
        service.registerCase(AllUsersSyncCase.getInstance().getCaseInfo());
    }
}
