package com.mpaas.demo.upgrade.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.mpaas.diagnose.ILogListener;

import java.util.List;

import static com.alipay.mobile.common.logging.api.LogEvent.Level.DEBUG_INT;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class DownloadLogListener implements ILogListener {


    @Override
    public String getTag() {
        return "DownloadCallback";
    }

    @Override
    public List<String> getProcesses() {
        return null;
    }

    @Override
    public boolean canFuzzyMatch() {
        return false;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {
        if (logEvent.getLevel().levelInt == DEBUG_INT) {
            if (logEvent.getMessage().contains("onProgress")) {
                UpgradeDiagnoseController.service.reportCase(DownloadProgressCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade下载回调onProgress功能成功");
            }
            if (logEvent.getMessage().contains("onFailed")) {
                UpgradeDiagnoseController.service.reportCase(DownloadFailedCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade下载回调onFailed功能成功");
            }
            if (logEvent.getMessage().contains("onFinish")) {
                UpgradeDiagnoseController.service.reportCase(DownloadFinishCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade下载回调onFinish功能成功");
            }
            if (logEvent.getMessage().contains("onPrepare")) {
                UpgradeDiagnoseController.service.reportCase(DownloadOnPrepareCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade下载回调onPrepare功能成功");
            }
            if (logEvent.getMessage().contains("onCancel")) {
                UpgradeDiagnoseController.service.reportCase(DownloadOnCancelCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade下载回调onCancel功能成功");
            }
        }
    }
}
