package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class DownloadOnCancelCase implements ICase {

    private static DownloadOnCancelCase sInstance;
    private CaseInfo mCaseInfo;

    private DownloadOnCancelCase() {

    }

    public static DownloadOnCancelCase getInstance() {
        if (sInstance == null) {
            synchronized (UpgradeCase.class) {
                if (sInstance == null) {
                    sInstance = new DownloadOnCancelCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Upgrade",
                    "Upgrade-000009",
                    "检测Download回调取消功能",
                    "手动检测Download回调取消功能",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {

    }
}
