package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class DownloadOnPrepareCase implements ICase {

    private static DownloadOnPrepareCase sInstance;
    private CaseInfo mCaseInfo;

    private DownloadOnPrepareCase() {

    }

    public static DownloadOnPrepareCase getInstance() {
        if (sInstance == null) {
            synchronized (UpgradeCase.class) {
                if (sInstance == null) {
                    sInstance = new DownloadOnPrepareCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Upgrade",
                    "Upgrade-000008",
                    "检测Upgrade准备下载功能",
                    "手动检测Upgrade准备下载功能",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {

    }
}
