package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.DiagnoseService;
import com.mpaas.diagnose.IDiagnoseController;
import com.mpaas.diagnose.ILogListener;
import com.mpaas.framework.adapter.api.MPFramework;

import java.util.LinkedList;

/**
 * Created by larry.cl.
 */
public class UpgradeDiagnoseController implements IDiagnoseController {

    public static DiagnoseService service;

    @Override
    public void init() {
        service = MPFramework.getExternalService(DiagnoseService.class.getName());
        registerAllCase();
    }

    @Override
    public LinkedList<ILogListener> registerLogListeners() {
        LinkedList<ILogListener> listeners = new LinkedList<>();
        listeners.add(new UpgradeLogListener());
        listeners.add(new DownloadLogListener());
        return listeners;
    }

    @Override
    public void runAllCase() {
        UpgradeLogListener.logRecordBuilder = new StringBuilder();
        UpgradeCase.getInstance().run();
        UpgradeNoNewVersionCase.getInstance().run();
        UpgradeDownloadedCase.getInstance().run();
        UpgradeExceptionCase.getInstance().run();
        UpgradeOnLimitCase.getInstance().run();
        DownloadProgressCase.getInstance().run();
        DownloadFailedCase.getInstance().run();
        DownloadFinishCase.getInstance().run();
        DownloadOnPrepareCase.getInstance().run();
        UpgradeUpdatingCase.getInstance().run();
        DownloadOnCancelCase.getInstance().run();
    }

    private void registerAllCase() {
        service.registerCase(UpgradeCase.getInstance().getCaseInfo());
        service.registerCase(UpgradeNoNewVersionCase.getInstance().getCaseInfo());
        service.registerCase(UpgradeDownloadedCase.getInstance().getCaseInfo());
        service.registerCase(UpgradeExceptionCase.getInstance().getCaseInfo());
        service.registerCase(UpgradeOnLimitCase.getInstance().getCaseInfo());
        service.registerCase(DownloadFailedCase.getInstance().getCaseInfo());
        service.registerCase(DownloadProgressCase.getInstance().getCaseInfo());
        service.registerCase(DownloadFinishCase.getInstance().getCaseInfo());
        service.registerCase(DownloadOnPrepareCase.getInstance().getCaseInfo());
        service.registerCase(UpgradeUpdatingCase.getInstance().getCaseInfo());
        service.registerCase(DownloadOnCancelCase.getInstance().getCaseInfo());
    }

}
