package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class UpgradeDownloadedCase implements ICase {

    private static UpgradeDownloadedCase sInstance;
    private CaseInfo mCaseInfo;

    private UpgradeDownloadedCase() {

    }

    public static UpgradeDownloadedCase getInstance() {
        if (sInstance == null) {
            synchronized (UpgradeDownloadedCase.class) {
                if (sInstance == null) {
                    sInstance = new UpgradeDownloadedCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Upgrade",
                    "Upgrade-000001",
                    "检测Upgrade升级已经下载完成功能",
                    "手动检测Upgrade升级已经下载完成功能",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
