package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class UpgradeExceptionCase implements ICase {

    private static UpgradeExceptionCase sInstance;
    private CaseInfo mCaseInfo;

    private UpgradeExceptionCase() {

    }

    public static UpgradeExceptionCase getInstance() {
        if (sInstance == null) {
            synchronized (UpgradeExceptionCase.class) {
                if (sInstance == null) {
                    sInstance = new UpgradeExceptionCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Upgrade",
                    "Upgrade-000002",
                    "检测Upgrade升级异常回调功能",
                    "手动检测Upgrade升级异常回调功能",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
