package com.mpaas.demo.upgrade.testcase;

import com.alipay.mobile.common.logging.api.LogEvent;
import com.mpaas.diagnose.ILogListener;

import java.util.List;

import static com.alipay.mobile.common.logging.api.LogEvent.Level.DEBUG_INT;
import static com.mpaas.diagnose.CaseInfo.RESULT_CODE_SUCCESS;

public class UpgradeLogListener implements ILogListener {

    private static final String upgradeSuccessSequenceText =
            "startCheck-showUpgradeDialog";
    public static StringBuilder logRecordBuilder = new StringBuilder();

    @Override
    public String getTag() {
        return "UpgradeCallBack";
    }

    @Override
    public List<String> getProcesses() {
        return null;
    }

    @Override
    public boolean canFuzzyMatch() {
        return false;
    }

    @Override
    public void onLogAppend(LogEvent logEvent, String s) {

        if (logEvent.getLevel().levelInt == DEBUG_INT) {
            if (logEvent.getMessage().contains("startCheck")) {
                logRecordBuilder.append("startCheck-");
            }
            if (logEvent.getMessage().contains("showUpgradeDialog")) {
                logRecordBuilder.append("showUpgradeDialog");
            }
            if (upgradeSuccessSequenceText.equals(logRecordBuilder.toString())) {
                UpgradeDiagnoseController.service.reportCase(UpgradeCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "成功获取新版本");
            }
            if (logEvent.getMessage().contains("onException")) {
                UpgradeDiagnoseController.service.reportCase(UpgradeExceptionCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade升级回调onException功能成功");
            }
            if (logEvent.getMessage().contains("dealDataInValid")) {
                UpgradeDiagnoseController.service.reportCase(UpgradeExceptionCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade升级回调dealDataInValid功能成功");
            }
            if (logEvent.getMessage().contains("dealHasNoNewVersion")) {
                UpgradeDiagnoseController.service.reportCase(UpgradeNoNewVersionCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade升级回调dealHasNoNewVersion功能成功");
            }
            if (logEvent.getMessage().contains("alreadyDownloaded")) {
                UpgradeDiagnoseController.service.reportCase(UpgradeDownloadedCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade升级回调alreadyDownloaded功能成功");
            }
            if (logEvent.getMessage().contains("onLimit")) {
                UpgradeDiagnoseController.service.reportCase(UpgradeOnLimitCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade升级回调onLimit功能成功");
            }
            if (logEvent.getMessage().contains("isUpdating")) {
                UpgradeDiagnoseController.service.reportCase(UpgradeUpdatingCase.getInstance().getCaseInfo(), RESULT_CODE_SUCCESS, "Upgrade升级回调isUpdating功能成功");
            }
        }
    }

}
