package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class UpgradeNoNewVersionCase implements ICase {

    private static UpgradeNoNewVersionCase sInstance;
    private CaseInfo mCaseInfo;

    private UpgradeNoNewVersionCase() {

    }

    public static UpgradeNoNewVersionCase getInstance() {
        if (sInstance == null) {
            synchronized (UpgradeNoNewVersionCase.class) {
                if (sInstance == null) {
                    sInstance = new UpgradeNoNewVersionCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Upgrade",
                    "Upgrade-000003",
                    "检测Upgrade升级无新版本功能",
                    "手动检测Upgrade升级无新版本功能",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
