package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class UpgradeOnLimitCase implements ICase {

    private static UpgradeOnLimitCase sInstance;
    private CaseInfo mCaseInfo;

    private UpgradeOnLimitCase() {

    }

    public static UpgradeOnLimitCase getInstance() {
        if (sInstance == null) {
            synchronized (UpgradeOnLimitCase.class) {
                if (sInstance == null) {
                    sInstance = new UpgradeOnLimitCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Upgrade",
                    "Upgrade-000004",
                    "检测Upgrade升级间隔小于设置功能",
                    "手动检测Upgrade升级间隔小于设置功能",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
