package com.mpaas.demo.upgrade.testcase;

import com.mpaas.diagnose.CaseInfo;
import com.mpaas.diagnose.ICase;

/**
 * Created by larry.cl.
 */
public class UpgradeUpdatingCase implements ICase {

    private static UpgradeUpdatingCase sInstance;
    private CaseInfo mCaseInfo;

    private UpgradeUpdatingCase() {

    }

    public static UpgradeUpdatingCase getInstance() {
        if (sInstance == null) {
            synchronized (UpgradeUpdatingCase.class) {
                if (sInstance == null) {
                    sInstance = new UpgradeUpdatingCase();
                }
            }
        }
        return sInstance;
    }

    @Override
    public CaseInfo getCaseInfo() {
        if (mCaseInfo == null) {
            mCaseInfo = new CaseInfo(
                    "Upgrade",
                    "Upgrade-000010",
                    "检测Upgrade正在更新功能",
                    "手动检测Upgrade正在更新功能",
                    true
            );
        }
        return mCaseInfo;
    }

    @Override
    public void run() {
    }
}
